const _ = require("lodash");

class SimpleDependencyEntry {

  constructor() {

  }

  static of(name, dependency) {
    if (!SimpleDependencyEntry.isValidName(name)) {
      throw new TypeError(`Invalid name. Type='${typeof name}'`);
    }

    const entry = new SimpleDependencyEntry();
    entry.name = SimpleDependencyEntry.formatName(name);
    entry.dependency = dependency;

    return entry;
  }

  static formatName(name) {
    if (!_.isString(name)) {
      throw new TypeError(`Invalid type name '${typeof name}'. Expected string`);
    }

    return name.trim();
  }

  static isValidName(name) {
    return _.isString(name) && name.trim().length > 0;
  }
}

exports.SimpleDependencyEntry = module.exports.SimpleDependencyEntry = SimpleDependencyEntry;
